/*
* The Apache Software License, Version 1.1
*
* Copyright (c) 2002 The Ant-Contrib project.  All rights
* reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
* 1. Redistributions of source code must retain the above copyright
*    notice, this list of conditions and the following disclaimer.
*
* 2. Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in
*    the documentation and/or other materials provided with the
*    distribution.
*
* 3. The end-user documentation included with the redistribution, if
*    any, must include the following acknowlegement:
*       "This product includes software developed by the
*        Apache Software Foundation (http://www.apache.org/)."
*    Alternately, this acknowlegement may appear in the software itself,
*    if and wherever such third-party acknowlegements normally appear.
*
* 4. The names "The Jakarta Project", "Ant", and "Apache Software
*    Foundation" must not be used to endorse or promote products derived
*    from this software without prior written permission. For written
*    permission, please contact apache@apache.org.
*
* 5. Products derived from this software may not be called "Apache"
*    nor may "Apache" appear in their names without prior written
*    permission of the Apache Group.
*
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
* WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
* ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
* USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
* OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
* OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
* SUCH DAMAGE.
* ====================================================================
*
* This software consists of voluntary contributions made by many
* individuals on behalf of the Apache Software Foundation.  For more
* information on the Apache Software Foundation, please see
* <http://www.apache.org/>.
*/
package net.sf.antcontrib.cpptasks.os390;

import java.util.Vector;
/**
* A add-in class for IBM (r) OS/390 compilers and linkers
*
* @author Hiram Chirino (cojonudo14@hotmail.com)
*/
public class OS390Processor
{
    private OS390Processor() {}

    public static String getCommandFileSwitch(String cmdFile) {
      StringBuffer buf = new StringBuffer("@");
      if(cmdFile.indexOf(' ') >= 0) {
        buf.append('\"');
        buf.append(cmdFile);
        buf.append('\"');
      }
      else {
        buf.append(cmdFile);
      }
      return buf.toString();
    }

    public static String[] getOutputFileSwitch(String outPath) {
      StringBuffer buf = new StringBuffer("-o ");
      if(outPath.indexOf(' ') >= 0) {
        buf.append('\"');
        buf.append(outPath);
        buf.append('\"');
      }
      else {
        buf.append(outPath);
      }
      String[] retval = new String[] { buf.toString() };
      return retval;
    }

    public static String getIncludeDirSwitch(String includeDir) {
      return "-I" + includeDir;
    }

    public static void addWarningSwitch(Vector args, int level) {
      switch(level) {
      	/*
        case 0:
        args.addElement("/W0");
        break;

        case 1:
        args.addElement("/W1");
        break;

        case 2:
        break;

        case 3:
        args.addElement("/W3");
        break;

        case 4:
        args.addElement("/W4");
        break;
	    */
      }
    }


       private static int addLibraryPatterns(
      String[] libnames,
      StringBuffer buf,
      String prefix,
      String extension,
      String[] patterns,
      int offset) {
      for(int i = 0; i < libnames.length; i++) {
        buf.setLength(0);
        buf.append(prefix);
        buf.append(libnames[i]);
        buf.append(extension);
        patterns[offset + i] = buf.toString();
      }
      return offset + libnames.length;
    }

    public static String[] getLibraryPatterns(String[] libnames) {
      StringBuffer buf = new StringBuffer();
      String[] patterns = new String[libnames.length * 3];
      int offset = addLibraryPatterns(libnames,buf,"lib",".a",patterns,0);
      offset = addLibraryPatterns(libnames,buf, "",".x",patterns,offset);
      offset = addLibraryPatterns(libnames,buf, "",".o",patterns,offset);
      return patterns;
    }

    public static boolean isCaseSensitive() {
      return true;
    }

}

